/**
 * Copyright 2010 JBoss Inc
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package jbpm;

import java.util.ArrayList;
import java.util.List;

import junit.framework.TestCase;

import org.drools.KnowledgeBase;
import org.drools.builder.KnowledgeBuilder;
import org.drools.builder.KnowledgeBuilderFactory;
import org.drools.builder.ResourceType;
import org.drools.event.process.ProcessCompletedEvent;
import org.drools.event.process.ProcessEventListener;
import org.drools.event.process.ProcessNodeLeftEvent;
import org.drools.event.process.ProcessNodeTriggeredEvent;
import org.drools.event.process.ProcessStartedEvent;
import org.drools.event.process.ProcessVariableChangedEvent;
import org.drools.io.ResourceFactory;
import org.drools.runtime.StatefulKnowledgeSession;
import org.drools.runtime.process.WorkflowProcessInstance;

public class SimpleBPMNProcessTest extends TestCase{

    
    public void testMultipleInOutgoingSequenceFlowsWithWaitState() throws Exception {
    	System.setProperty("jbpm.enable.multi.con", "true");
        KnowledgeBase kbase = createKnowledgeBase("noDemoJbpm5.testMultiConn.bpmn2");
        StatefulKnowledgeSession ksession = createKnowledgeSession(kbase);
        final List<Object> list = new ArrayList<Object>();
        ksession.addEventListener(new ProcessEventListener() {
			
			public void beforeVariableChanged(ProcessVariableChangedEvent event) {
				// TODO Auto-generated method stub
				
			}
			
			public void beforeProcessStarted(ProcessStartedEvent event) {
				// TODO Auto-generated method stub
				
			}
			
			public void beforeProcessCompleted(ProcessCompletedEvent event) {
				// TODO Auto-generated method stub
				
			}
			
			public void beforeNodeTriggered(ProcessNodeTriggeredEvent event) {
				// TODO Auto-generated method stub
				
			}
			
			public void beforeNodeLeft(ProcessNodeLeftEvent event) {
				// TODO Auto-generated method stub
				
			}
			
			public void afterVariableChanged(ProcessVariableChangedEvent event) {
				// TODO Auto-generated method stub
				
			}
			
			public void afterProcessStarted(ProcessStartedEvent event) {
				// TODO Auto-generated method stub
				
			}
			
			public void afterProcessCompleted(ProcessCompletedEvent event) {
				// TODO Auto-generated method stub
				
			}
			
			public void afterNodeTriggered(ProcessNodeTriggeredEvent event) {
				if ("Task2".equals(event.getNodeInstance().getNodeName()))
				{
					list.add(event);
				}
				System.out.println("node name: "+event.getNodeInstance().getNodeName());
			}
			
			public void afterNodeLeft(ProcessNodeLeftEvent event) {
				// TODO Auto-generated method stub
				
			}
		});
        ksession.startProcess("noDemoJbpm5.testMultiConn");
        assertEquals(1,list.size());
        System.clearProperty("jbpm.enable.multi.con");
    }
    
	protected KnowledgeBase createKnowledgeBase(String... process) {
		KnowledgeBuilder kbuilder = KnowledgeBuilderFactory.newKnowledgeBuilder();
		for (String p: process) {
			kbuilder.add(ResourceFactory.newClassPathResource(p), ResourceType.BPMN2);
		}
		return kbuilder.newKnowledgeBase();
	}
	
	protected StatefulKnowledgeSession createKnowledgeSession(KnowledgeBase kbase) {

			StatefulKnowledgeSession result = kbase.newStatefulKnowledgeSession();
			return result;
		}
	
}
